



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>单元测试 mock EF 中DbContext 和DbSet Include</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">单元测试 mock EF 中DbContext 和DbSet Include</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 11:53:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>现在EF越来越流行了，很多时候业务成都是直接访问DbContext 和DbSet来操作数据的。 那么我们测试的时候如何来mock这2个对象了？现在时间很晚了， 就直接贴code吧</p>
<p>首先看看的我们DbContext的类吧：</p>
<div>
<pre class="prettyprint linenums"> public class BloggerEntities : DbContext<br />
    {<br />
        public BloggerEntities()<br />
            : base("BloggerEntities")<br />
        {<br />
            Configuration.ProxyCreationEnabled = false;<br />
        }

        public virtual DbSet&lt;Blog&gt; Blogs { get; set; }<br />
        public virtual DbSet&lt;Article&gt; Articles { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)<br />
        {<br />
            modelBuilder.Configurations.Add(new ArticleConfiguration());<br />
            modelBuilder.Configurations.Add(new BlogConfiguration());<br />
        }<br />
    }</pre>
</div>
<p>public virtual DbSet&lt;Blog&gt; Blogs { get; set; }<br />        public virtual DbSet&lt;Article&gt; Articles { get; set; }</p>
<p>注意了，我一般DbSet属性是没有添加virtual， 结果上面的&nbsp;mockedContext.Setup(lambdaExpression).Returns(method.Invoke(null, new[] { listForFakeTable }));这句一直报错，搞了我2个小时都没有搞定。不能mock 实例方法。</p>
<p>单元测试code：</p>
<div>
<pre class="prettyprint linenums"> static void Main(string[] args)<br />
        {<br />
            var context = EntityFrameworkMockHelper.GetMockContext&lt;BloggerEntities&gt;().Object;<br />
            context.Articles.Add(new Article<br />
            {<br />
                Author = "Gavin",<br />
                BlogID = ,<br />
                Contents = "test",<br />
                ID = ,<br />
                Title = "test title",<br />
                URL = "article URL"<br />
            });<br />
            List&lt;Blog&gt; blogs = new List&lt;Blog&gt; {<br />
            new Blog<br />
            {<br />
                ID = ,<br />
                URL = "blog url",<br />
                Name = "blogs name"<br />
            },<br />
            new Blog<br />
            {<br />
                ID = ,<br />
                URL = "blog url",<br />
                Name = "blogs name2222"<br />
            }<br />
             };<br />
            context.Articles.First().Blog = blogs[];

           //add<br />
           context.Blogs.AddRange(blogs);<br />
           //query<br />
           var query1 = (from a in context.Articles<br />
                         join b in context.Blogs on a.BlogID equals b.ID<br />
                         select new { Author = a.Author, BlogName = b.Name }).ToList();<br />
           //remove<br />
           var blog = context.Blogs.FirstOrDefault(x =&gt; x.Name == "blogs name2222");<br />
           context.Blogs.Remove(blog);<br />
           //update<br />
           context.Articles.FirstOrDefault(x=&gt;x.ID==).URL = "updated url";<br />
           var query2 = (from a in context.Articles<br />
                         join b in context.Blogs on a.BlogID equals b.ID<br />
                         select new { Author = a.Author, ArticleUrl = a.URL }).ToList();

            EFService service = new EFService(context);<br />
            var includetest1 = service.GetArticles();<br />
            var includetest2 = service.GetArticles2();<br />
            var includetest3 = service.GetArticles3();<br />
        }</pre>
</div>
<p>注意为了 测试include 这里我单独写了一个 service</p>
<div>
<pre class="prettyprint linenums">  public class EFService<br />
    {<br />
        BloggerEntities DBContext { set; get; }<br />
        public EFService(BloggerEntities ctx)<br />
        {<br />
            DBContext = ctx;<br />
        }<br />
        public List&lt;Article&gt; GetArticles()<br />
        {<br />
            return DBContext.Articles.Include("Blog").ToList();<br />
        }<br />
        public List&lt;Article&gt; GetArticles2()<br />
        {<br />
            return DBContext.Articles.Include(x=&gt;x.Blog).ToList();<br />
        }<br />
        public List&lt;Article&gt; GetArticles3()<br />
        {<br />
            return (from a in DBContext.Articles select a).Include(x =&gt; x.Blog).ToList();<br />
        }<br />
    }</pre>
</div>
<p>我这里的EFService 和BloggerEntities在同一个 程序集里面， 实际上我们应该分开的。</p>
<p>EntityFrameworkMockHelper 的实现如下：</p>
<div>
<pre class="prettyprint linenums">  public class MockedDbContext&lt;T&gt; : Mock&lt;T&gt; where T : DbContext<br />
    {<br />
        public Dictionary&lt;string, object&gt; Tables<br />
        {<br />
            get { return _Tables ?? (_Tables = new Dictionary&lt;string, object&gt;()); }<br />
        }<br />
        private Dictionary&lt;string, object&gt; _Tables;

    }<br />
    public static class EntityFrameworkMockHelper<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// Returns a mock of a DbContext<br />
        /// &lt;/summary&gt;<br />
        /// &lt;typeparam name="T"&gt;&lt;/typeparam&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static MockedDbContext&lt;T&gt; GetMockContext&lt;T&gt;() where T : DbContext<br />
        {<br />
            var instance = new MockedDbContext&lt;T&gt;();<br />
            instance.MockTables();<br />
            return instance;<br />
        }

        /// &lt;summary&gt;<br />
        /// Use this method to mock a table, which is a DbSet{T} oject, in Entity Framework.<br />
        /// Leave the second list null if no adds or deletes are used.<br />
        /// &lt;/summary&gt;<br />
        /// &lt;typeparam name="T"&gt;The table data type&lt;/typeparam&gt;<br />
        /// &lt;param name="table"&gt;A List{T} that is being use to replace a database table.&lt;/param&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public static DbSet&lt;T&gt; MockDbSet&lt;T&gt;(List&lt;T&gt; table) where T : class<br />
        {<br />
            var dbSet = new Mock&lt;DbSet&lt;T&gt;&gt;();<br />
            dbSet.As&lt;IQueryable&lt;T&gt;&gt;().Setup(q =&gt; q.Provider).Returns(() =&gt; table.AsQueryable().Provider);<br />
            dbSet.As&lt;IQueryable&lt;T&gt;&gt;().Setup(q =&gt; q.Expression).Returns(() =&gt; table.AsQueryable().Expression);<br />
            dbSet.As&lt;IQueryable&lt;T&gt;&gt;().Setup(q =&gt; q.ElementType).Returns(() =&gt; table.AsQueryable().ElementType);<br />
            dbSet.As&lt;IQueryable&lt;T&gt;&gt;().Setup(q =&gt; q.GetEnumerator()).Returns(() =&gt; table.AsQueryable().GetEnumerator());<br />
            dbSet.Setup(set =&gt; set.Add(It.IsAny&lt;T&gt;())).Callback&lt;T&gt;(table.Add);<br />
            dbSet.Setup(set =&gt; set.AddRange(It.IsAny&lt;IEnumerable&lt;T&gt;&gt;())).Callback&lt;IEnumerable&lt;T&gt;&gt;(table.AddRange);<br />
            dbSet.Setup(set =&gt; set.Remove(It.IsAny&lt;T&gt;())).Callback&lt;T&gt;(t =&gt; table.Remove(t));<br />
            dbSet.Setup(set =&gt; set.RemoveRange(It.IsAny&lt;IEnumerable&lt;T&gt;&gt;())).Callback&lt;IEnumerable&lt;T&gt;&gt;(ts =&gt;<br />
            {<br />
                foreach (var t in ts) { table.Remove(t); }<br />
            });<br />
            dbSet.Setup(set =&gt; set.Include(It.IsAny&lt;string&gt;())).Returns(dbSet.Object);<br />
            return dbSet.Object;<br />
        }

        /// &lt;summary&gt;<br />
        /// Mocks all the DbSet{T} properties that represent tables in a DbContext.<br />
        /// &lt;/summary&gt;<br />
        /// &lt;typeparam name="T"&gt;&lt;/typeparam&gt;<br />
        /// &lt;param name="mockedContext"&gt;&lt;/param&gt;<br />
        public static void MockTables&lt;T&gt;(this MockedDbContext&lt;T&gt; mockedContext) where T : DbContext<br />
        {<br />
            Type contextType = typeof(T);<br />
            var dbSetProperties = contextType.GetProperties().Where(prop =&gt; (prop.PropertyType.IsGenericType) &amp;&amp; prop.PropertyType.GetGenericTypeDefinition() == typeof(DbSet&lt;&gt;));<br />
            foreach (var prop in dbSetProperties)<br />
            {<br />
                var dbSetGenericType = prop.PropertyType.GetGenericArguments()[];<br />
                Type listType = typeof(List&lt;&gt;).MakeGenericType(dbSetGenericType);<br />
                var listForFakeTable = Activator.CreateInstance(listType);<br />
                var parameter = Expression.Parameter(contextType);<br />
                var body = Expression.PropertyOrField(parameter, prop.Name);<br />
                var lambdaExpression = Expression.Lambda&lt;Func&lt;T, object&gt;&gt;(body, parameter);<br />
                var method = typeof(EntityFrameworkMockHelper).GetMethod("MockDbSet").MakeGenericMethod(dbSetGenericType);<br />
                mockedContext.Setup(lambdaExpression).Returns(method.Invoke(null, new[] { listForFakeTable }));<br />
                mockedContext.Tables.Add(prop.Name, listForFakeTable);<br />
            }<br />
        }

    }</pre>
</div>
<p>参考：</p>
<p><a href="https://msdn.microsoft.com/en-gb/data/dn314429" rel="external nofollow noreferrer">Testing with a mocking framework (EF6 onwards)</a></p>
<p><a href="http://www.rhyous.com/2015/04/10/how-to-mock-an-entity-framework-dbcontext-and-its-dbset-properties/" rel="external nofollow noreferrer">How to mock an Entity Framework DbContext and its DbSet properties</a></p>
<p>文件下载地址：http://download.csdn.net/detail/dz45693/9514948</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqln7ke8.html">logstash读取redis数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxyxvd9.html">Hadoop 调研笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgg6l9.html">RabbitMQ安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wn2x9.html">Mysql InnoDB行锁实现方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8edzxe9.html">EntityFramework 6&period;0&amp;lt&semi; Code First &amp;gt&semi; 连接 Mysql数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/96odgx39.html">HDU 5266 pog loves szh III &lpar;LCA&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4mlr9.html">关于keil单片机编程中的data&comma;idata&comma;xdata&comma;pdata&comma;code数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdem2zj9.html">Csharp多态的实现&lpar;抽象类&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrgo38.html">Bootstrap  &amp;amp&semi; 响应式</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p4zlj8.html">LeetCode &num;1 TwoSum</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp24vzq.html">mysql的服务器构成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvveyl8.html">Plugin with id &amp;&num;39&semi;com&period;novoda&period;bintray-release&amp;&num;39&semi; not found&period;的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gd126q.html">qemu 对虚机的地址空间管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5v72mq.html">&lbrack;UE4&rsqb;让机器人开枪射击</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26gyo9.html">Linux服务器有什么优势？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ex0m19.html">Metasploit简单应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjjlmjq.html">Python模拟Linux的Crontab， 写个任务计划需求</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pnmv3q.html">Linux内核分析-Linux内核如何装载和启动一个可执行程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjz6528.html">react-native开发总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pr6ng8.html">mysql命令收集</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8egvok9.html">pictures of you</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p4r7d9.html">Python动态生成变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4olg08.html">python 之 theano学习：</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq171k6q.html">&lbrack;转&rsqb;框架模式 MVC 在Android中的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kexn58.html">更改OneDrive同步文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnxpgj9.html">Linux中vi、vim命令大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdynljq.html">mysql 授权</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p4zok9.html">用c&num;开发微信 &lpar;19&rpar; 公众平台接口权限列表说明 - 订阅号、服务号认证后的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zzmm18.html">oracle ORA-00911 问题 解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvygmoq.html">mysql 去除空格</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
